import React, { Component, Fragment } from 'react';
import { interval, Subject } from 'rxjs';
import { reduce } from 'rxjs/operators';

class Rc extends Component {
  state = {
    count: 0
  };
  shouldComponentUpdate(_, nextState) {
    return nextState !== this.state;
  }
  componentDidMount() {
    const { count$ } = this.props;
    count$.subscribe(count => {
      this.setState({ count });
    });
  }
  render() {
    return <div>{this.state.count}</div>;
  }
}
window.interval = interval;

export class Reactive extends Component {
  interval$ = interval(1000);
  subject$ = new Subject();

  componentDidMount() {
    this.subject$.subscribe(e => console.log(e));
  }

  render() {
    return (
      <Fragment>
        <div>hi</div>
        <button onClick={this.subject$.next}>touch</button>
        <Rc count$={this.interval$} />
      </Fragment>
    );
  }
}
