"use strict";

exports.__esModule = true;
exports.nodeSchema = exports.pageSchema = exports.gatsbyConfigSchema = void 0;

const Joi = require(`joi`);

const gatsbyConfigSchema = Joi.object().keys({
  polyfill: Joi.boolean(),
  siteMetadata: Joi.object(),
  pathPrefix: Joi.string(),
  mapping: Joi.object(),
  plugins: Joi.array(),
  proxy: Joi.object().keys({
    prefix: Joi.string().required(),
    url: Joi.string().required()
  }),
  developMiddleware: Joi.func()
});
exports.gatsbyConfigSchema = gatsbyConfigSchema;
const pageSchema = Joi.object().keys({
  path: Joi.string().required(),
  matchPath: Joi.string(),
  component: Joi.string().required(),
  componentChunkName: Joi.string().required(),
  context: Joi.object(),
  pluginCreator___NODE: Joi.string(),
  pluginCreatorName: Joi.string()
}).unknown();
exports.pageSchema = pageSchema;
const nodeSchema = Joi.object().keys({
  id: Joi.string().required(),
  children: Joi.array().items(Joi.string(), Joi.object().forbidden()),
  parent: Joi.string().allow(null),
  fields: Joi.object(),
  internal: Joi.object().keys({
    contentDigest: Joi.string().required(),
    mediaType: Joi.string(),
    type: Joi.string().required(),
    owner: Joi.string().required(),
    fieldOwners: Joi.array(),
    content: Joi.string().allow(``),
    description: Joi.string(),
    ignoreType: Joi.boolean()
  }).unknown({
    allow: false
  }) // Don't allow non-standard fields

}).unknown();
exports.nodeSchema = nodeSchema;
//# sourceMappingURL=joi.js.map