import { StateValue, ActivityMap, EventObject, StateInterface, HistoryValue, ActionObject, EventType } from './types';
import { StateTree } from './StateTree';
export declare function stateValuesEqual(a: StateValue, b: StateValue): boolean;
export declare class State<TContext, TEvents extends EventObject = EventObject> implements StateInterface<TContext> {
    value: StateValue;
    context: TContext;
    historyValue?: HistoryValue | undefined;
    history?: State<TContext, EventObject> | undefined;
    actions: Array<ActionObject<TContext>>;
    activities: ActivityMap;
    data: Record<string, any>;
    /**
     * Internal event queue
     */
    events: TEvents[];
    tree?: StateTree;
    static from<TC, TE extends EventObject = EventObject>(stateValue: State<TC, TE> | StateValue, context: TC): State<TC, TE>;
    static inert<TC, TE extends EventObject = EventObject>(stateValue: State<TC> | StateValue, context: TC): State<TC, TE>;
    constructor(value: StateValue, context: TContext, historyValue?: HistoryValue | undefined, history?: State<TContext, EventObject> | undefined, actions?: Array<ActionObject<TContext>>, activities?: ActivityMap, data?: Record<string, any>, 
    /**
     * Internal event queue
     */
    events?: TEvents[], tree?: StateTree);
    readonly nextEvents: EventType[];
    toStrings(value?: StateValue, delimiter?: string): string[];
    matches(parentStateValue: StateValue): boolean;
    readonly changed: boolean | undefined;
}
