import { Action, Event, EventObject, SendAction, SendActionOptions, CancelAction, ActionObject, Assigner, AssignAction, ActionFunction, ActionFunctionMap, ActivityActionObject, ActionTypes, ActivityDefinition, Invocation, RaiseEvent } from './types';
import * as actionTypes from './actionTypes';
export { actionTypes };
export declare function toEventObject<TEvents extends EventObject>(event: Event<TEvents>): TEvents;
export declare function toActionObject<TContext>(action: Action<TContext>, actionFunctionMap?: ActionFunctionMap<TContext>): ActionObject<TContext>;
export declare function toActivityDefinition<TContext>(action: string | ActivityDefinition<TContext>): ActivityDefinition<TContext>;
export declare const toActionObjects: <TContext>(action: Action<TContext>[] | undefined, actionFunctionMap?: Record<string, ActionObject<TContext> | ActionFunction<TContext>> | undefined) => ActionObject<TContext>[];
export declare function raise<TContext, TEvents extends EventObject>(eventType: TEvents['type']): RaiseEvent<TContext, TEvents>;
export declare function send<TContext, TEvents extends EventObject>(event: Event<TEvents>, options?: SendActionOptions): SendAction<TContext, TEvents>;
export declare function sendParent<TContext, TEvents extends EventObject>(event: Event<TEvents>, options?: SendActionOptions): SendAction<TContext, TEvents>;
export declare function log<TContext, TEvents extends EventObject>(expr: (ctx: TContext, event: TEvents) => void, label?: string): {
    type: ActionTypes;
    label: string | undefined;
    expr: (ctx: TContext, event: TEvents) => void;
};
export declare const cancel: (sendId: string | number) => CancelAction;
export declare function start<TContext>(activity: string | ActivityDefinition<TContext>): ActivityActionObject<TContext>;
export declare function stop<TContext>(activity: string | ActivityDefinition<TContext>): ActivityActionObject<TContext>;
export declare const assign: <TContext, TEvents extends EventObject = EventObject>(assignment: Assigner<TContext, TEvents> | Partial<{ [K in keyof TContext]: ((extState: TContext, event: TEvents) => TContext[K]) | TContext[K]; }>) => AssignAction<TContext, TEvents>;
export declare function isActionObject<TContext>(action: Action<TContext>): action is ActionObject<TContext>;
export declare function after(delay: number, id?: string): string;
export declare function done(id: string): string;
export declare function invoke<TContext>(invokeConfig: string | Invocation<TContext>, options?: Partial<Invocation<TContext>>): ActivityDefinition<TContext>;
